<template>
    <div v-if="orderType === 'PRODUCT'">
        <span style="color: #333333; font-size: medium; font-weight: bolder; padding-left: 10px;">
            Extras: {{ ingredients.length }}
        </span>

        <div v-show="extraIngredientSize == 0">
            <v-chip-group>
                <v-chip
                    small
                    class="ma-1"
                    color="#3949AB "
                    label
                    outlined
                    v-for="ingredient in ingredients"
                    :key="ingredient.ingredientId"
                >
                    {{ ingredient.localizedName }}
                    <extra-ingredients-item
                        :ingredient-id="ingredient.ingredientId"
                        :order-id="orderId"
                        :dis-id="disId"
                        :order-type="orderType"
                        @extraSize="extraSize"
                    >
                    </extra-ingredients-item>
                </v-chip>
            </v-chip-group>
        </div>
        <div v-show="extraIngredientSize > 0">
            <v-list>
                <v-list-item large v-for="ingredient in ingredients" :key="ingredient.ingredientId">
                    {{ ingredient.localizedName }}
                    <extra-ingredients-item
                        :ingredient-id="ingredient.ingredientId"
                        :order-id="orderId"
                        :dis-id="disId"
                        :order-type="orderType"
                        @extraSize="extraSize"
                    >
                    </extra-ingredients-item>
                </v-list-item>
            </v-list>
        </div>
    </div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator';
import { db } from '@/config/firebase';
import { ORDER_DISH, ORDER_DISH_INGREDIENT, ORDERS } from '@/config/collectionsName';
import { serializeIngredientOrderDish } from '@/config/serializables';
import { IngredientOrderDish } from '@/model/order/IngredientOrderDish';
import { ExtraIngredientOrderDish } from '@/model/order/ExtraIngredientOrderDish';
import ExtraIngredientsItem from '@/components/order/ExtraIngredientsItem.vue';

@Component({
    components: { ExtraIngredientsItem }
})
export default class IngredientItem extends Vue {
    @Prop({ default: '' })
    readonly disId!: string;

    readonly ingredients: IngredientOrderDish[] = [];
    readonly extraIngredients: ExtraIngredientOrderDish[] = [];

    @Prop({ default: '' })
    readonly orderId!: string;
    @Prop({ default: '' })
    readonly orderType!: string;

    extraIngredientSize = 0;

    created() {
        this.$bind(
            'ingredients',
            db
                .collection(ORDERS)
                .doc(this.orderId)
                .collection(ORDER_DISH)
                .doc(this.disId)
                .collection(ORDER_DISH_INGREDIENT)
                .where('selected', '==', true),
            { serialize: serializeIngredientOrderDish }
        );
    }

    extraSize(size: number) {
        return (this.extraIngredientSize = size);
    }
}
</script>

<style scoped></style>
